# buena-sdk
The most powerful LinkedIn automation and lead management API for modern sales teams and developers.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 2.0.0
- Package version: 1.0.0
- Generator version: 7.14.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.9+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import buena_sdk
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import buena_sdk
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import buena_sdk
from buena_sdk.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.buena.ai/api/v2
# See configuration.py for a list of all supported configuration parameters.
configuration = buena_sdk.Configuration(
    host = "https://api.buena.ai/api/v2"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'


# Enter a context with an instance of the API client
with buena_sdk.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = buena_sdk.DefaultApi(api_client)
    create_api_key_request = buena_sdk.CreateApiKeyRequest() # CreateApiKeyRequest | 

    try:
        # Create API Key
        api_response = api_instance.create_api_key(create_api_key_request)
        print("The response of DefaultApi->create_api_key:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->create_api_key: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.buena.ai/api/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**create_api_key**](docs/DefaultApi.md#create_api_key) | **POST** /keys | Create API Key
*DefaultApi* | [**create_lead**](docs/DefaultApi.md#create_lead) | **POST** /leads | Create Lead
*DefaultApi* | [**health_check**](docs/DefaultApi.md#health_check) | **GET** /health | Health Check
*DefaultApi* | [**list_api_keys**](docs/DefaultApi.md#list_api_keys) | **GET** /keys | List API Keys
*DefaultApi* | [**list_leads**](docs/DefaultApi.md#list_leads) | **GET** /leads | List Leads


## Documentation For Models

 - [ApiKey](docs/ApiKey.md)
 - [CreateApiKeyRequest](docs/CreateApiKeyRequest.md)
 - [CreateLeadRequest](docs/CreateLeadRequest.md)
 - [Error](docs/Error.md)
 - [HealthCheck200Response](docs/HealthCheck200Response.md)
 - [Lead](docs/Lead.md)
 - [ListLeads200Response](docs/ListLeads200Response.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="ApiKeyAuth"></a>
### ApiKeyAuth

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Author

support@buena.ai


